$Pref::Client::AdjustedBrickShift=1;
$Pref::Client::AdjustedBrickShiftEnabled=0;
$remapDivision[$remapCount] = "Adjusted Brick Shift";
$remapName[$remapCount] = "Toggle enabled";
$remapCmd[$remapCount] = "toggleAdjustedBrickShift";
$remapName[$remapCount++] = "Change value";
$remapCmd[($remapCount++)-1] = "openAdjustedBrickShiftGUI";

package AdjustedBrickShift
{
	function optionsDlg::applyGraphics(%x)
	{
		Parent::applyGraphics(%x);
		resetAdjustedBrickShiftIndicatorPosition();
	}
	function shiftBrickAway(%x)
	{
		if(!$Pref::Client::AdjustedBrickShiftEnabled || $superShift)
			Parent::shiftBrickAway(%x);
		else
			AdjustedBrickShift(%x,1,0,0);
	}
	function shiftBrickDown(%x)
	{
		if(!$Pref::Client::AdjustedBrickShiftEnabled || $superShift)
			Parent::shiftBrickDown(%x);
		else
		AdjustedBrickShift(%x,0,0,-3);
	}
	function shiftBrickLeft(%x)
	{
		if(!$Pref::Client::AdjustedBrickShiftEnabled || $superShift)
			Parent::shiftBrickLeft(%x);
		else
		AdjustedBrickShift(%x,0,1,0);
	}
	function shiftBrickRight(%x)
	{
		if(!$Pref::Client::AdjustedBrickShiftEnabled || $superShift)
			Parent::shiftBrickRight(%x);
		else
		AdjustedBrickShift(%x,0,-1,0);
	}
	function shiftBrickThirdDown(%x)
	{
		if(!$Pref::Client::AdjustedBrickShiftEnabled || $superShift)
			Parent::shiftBrickThirdDown(%x);
		else
		AdjustedBrickShift(%x,0,0,-1);
	}
	function shiftBrickThirdUp(%x)
	{
		if(!$Pref::Client::AdjustedBrickShiftEnabled || $superShift)
			Parent::shiftBrickThirdUp(%x);
		else
		AdjustedBrickShift(%x,0,0,1);
	}
	function shiftBrickTowards(%x)
	{
		if(!$Pref::Client::AdjustedBrickShiftEnabled || $superShift)
			Parent::shiftBrickTowards(%x);
		else
		AdjustedBrickShift(%x,-1,0,0);
	}
	function shiftBrickUp(%x)
	{
		if(!$Pref::Client::AdjustedBrickShiftEnabled || $superShift)
			Parent::shiftBrickUp(%x);
		else
		AdjustedBrickShift(%x,0,0,3);
	}
};
activatePackage(AdjustedBrickShift);

function toggleAdjustedBrickShift(%toggle)
{
	if(!%toggle)
		return;
	$Pref::Client::AdjustedBrickShiftEnabled=!$Pref::Client::AdjustedBrickShiftEnabled;
	AdjustedBrickShiftIndicator.setVisible($Pref::Client::AdjustedBrickShiftEnabled);
	%msg=($Pref::Client::AdjustedBrickShiftEnabled ? "<color:00ff00><font:impact:24>Adjusted Brick Shift is now ON." : "<color:ff0000><font:impact:24>Adjusted Brick Shift is now OFF.");
	clientCmdCenterPrint(%msg,2);
}

function AdjustedBrickShift(%check,%a,%b,%c)
{
	if(!%check)
		return;
	%use=$Pref::Client::AdjustedBrickShift;
	commandToServer('shiftBrick',%a*%use,%b*%use,%c*%use);
}

function GuiWindowCtrl::setCenterOffset(%this,%xOffset,%yOffset)
{
	%extentX=getWord(%this.extent,0);
	%extentY=getWord(%this.extent,1);
	%x=getWord(Crosshair.position,0)+%xOffset+32-(%extentX/2);
	%y=getWord(Crosshair.position,1)+%yOffset;
	%this.resize(%x,%y,%extentX,%extentY);
}

function openAdjustedBrickShiftGUI(%toggle)
{
	if(!%toggle || AdjustedBrickShiftGui.isAwake())
		return;
	canvas.pushDialog(AdjustedBrickShiftGui);
	AdjustedBrickShiftGui_input.setText("");
	AdjustedBrickShiftGui_window.setCenterOffset(0,0);
}

function AdjustedBrickShiftGUI_submit()
{
	%value=AdjustedBrickShiftGui_input.getValue();
	if(%value$="")
		return;
	%value=(%value<0 || %value>9999 ? 0 : %value);
	canvas.popDialog(AdjustedBrickShiftGui);
	$Pref::Client::AdjustedBrickShift=%value;
	clientCmdCenterPrint("<color:ffaa00><font:impact:24>Shift value changed to<color:ffffff> " @ %value @ "<color:ffaa00>.",2);
	AdjustedBrickShiftIndicator_text.setText("<just:center><font:verdana:25>" @ %value);
}

function resetAdjustedBrickShiftIndicatorPosition()
{
	%x=firstWord($pref::Video::resolution)-64;
	%y=getWord($pref::Video::resolution,1);
	%y=%y-200*(%y/600);
	AdjustedBrickShiftIndicator.resize(%x,%y,64,64);
}

new GuiBitmapCtrl(AdjustedBrickShiftIndicator) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "571 558";
	extent = "64 64";
	minExtent = "8 2";
	visible = "1";
	bitmap = "Add-Ons/Client_AdjustedBrickShift/shiftIndicator";
	wrap = "0";
	lockAspectRatio = "0";
	alignLeft = "0";
	overflowImage = "0";
	keepCached = "0";
	new GuiMLTextCtrl(AdjustedBrickShiftIndicator_text) {
		profile = "GuiMLTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 28";
		extent = "64 14";
		minExtent = "8 2";
		visible = "1";
		enabled = "1";
		clipToParent= "1";
		allowColorChars="1";
		text="<just:center><font:verdana:25>0";
		selectable= "0";
		lockAspectRatio = "0";
	};
};
PlayGui.add(AdjustedBrickShiftIndicator);
PlayGui.pushToBack(AdjustedBrickShiftIndicator);
resetAdjustedBrickShiftIndicatorPosition();
AdjustedBrickShiftIndicator.setVisible(0);
   
new GuiControl(AdjustedBrickShiftGui) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "640 480";
   minExtent = "8 2";
   enabled = "1";
   visible = "1";
   clipToParent = "1";

   new GuiWindowCtrl(AdjustedBrickShiftGui_window) {
      profile = "GuiWindowProfile";
      horizSizing = "right";
      vertSizing = "bottom";
      position = "273 226";
      extent = "139 67";
      minExtent = "8 2";
      enabled = "1";
      visible = "1";
      clipToParent = "1";
      text = "Shift Amount";
      maxLength = "255";
      resizeWidth = "0";
      resizeHeight = "0";
      canMove = "0";
      canClose = "0";
      canMinimize = "0";
      canMaximize = "0";
      minSize = "50 50";

      new GuiTextEditCtrl(AdjustedBrickShiftGui_input) {
         profile = "GuiTextEditProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "16 33";
         extent = "71 23";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
		 accelerator="enter";
		 altcommand="AdjustedBrickShiftGUI_submit();";
         clipToParent = "1";
         maxLength = "4";
         historySize = "0";
         password = "0";
         tabComplete = "0";
         sinkAllKeyEvents = "0";
      };
      new GuiButtonCtrl() {
         profile = "GuiButtonSmProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "94 32";
         extent = "34 28";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
		 command= "AdjustedBrickShiftGUI_submit();";
         text = ">";
         groupNum = "-1";
         buttonType = "PushButton";
      };
   };
};